/*
** iplog_filter.h - iplog filter data.
** Copyright (C) 1999,2000 Ryan McCabe <odin@numb.org>
**
** This program is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License, version 2,
** as published by the Free Software Foundation.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA
**
** $Id: iplog_filter.h,v 1.6 2000/01/07 01:13:36 odin Exp $
*/

#ifndef __IPLOG_FILTER_H
#define __IPLOG_FILTER_H

#define NS_FILE "/etc/resolv.conf"

#define ADDR_MATCH_ALL 0
#define MASK_MATCH_ONE 0xffffffff
#define MASK_MATCH_ALL 0
#define TYPE_MATCH_ALL 0xffff

#define EVERYTHING "*"

enum { FIL_TCP, FIL_UDP, FIL_ICMP };

struct filter_data {
	struct filter_data *next;
	struct port_range {
		port_t min;
		port_t max;
		bool not;
	} sport, dport;
	struct addr_entry {
		addr_t addr;
		addr_t mask;
		bool not;
	} src, dst;
	bool not;
};

void add_dns_ignore_rules(void);
void read_filters(const u_char *);
void destroy_filter_list(u_int prot);
bool apply_icmp_filter(u_int, const struct ip *, u_char);
bool apply_filter(u_int, const struct ip *, port_t, port_t);

#endif /* __IPLOG_FILTER_H */
/* vim:ts=4:sw=8:tw=0 */
